<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>UNIQORN -- The Universal Neural-network Interface for Quantum Observable Readout from N-body wavefunctions: UNIQORN &ndash; Universal Neural Network Interface for Quantum Observable Readout from N-body wavefunctions</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="Uniqorn_logo_230.jpg"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">UNIQORN -- The Universal Neural-network Interface for Quantum Observable Readout from N-body wavefunctions
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('index.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title"><a class="el" href="namespaceUNIQORN.html">UNIQORN</a> &ndash; Universal Neural Network Interface for Quantum Observable Readout from N-body wavefunctions </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>&mdash; VERSION 0.4 BETA &mdash;</p>
<h2><a class="anchor" id="autotoc_md1"></a>
Introduction</h2>
<p>This repository contains some python and bash scripts that implement machine learning tasks using the Keras library. The code performs regression and/or classification tasks on various observables from data obtained from MCTDH-X simulations.</p>
<p>Currently, only single-shot images as input data are supported, but in the future using correlation functions as input will be implemented.</p>
<p>The quantities that can be analyzed so far are fragmentation, particle number, density distributions, the potential, and correlation functions.</p>
<p>Click this to download the single-shot <a href="https://drive.google.com/file/d/1Du8KRhsITezlMVWEBrLOnDIAfFZOPcEj/view?usp=sharing">DATA</a>.</p>
<p>This data should be placed in the same folder as the code in this repository. The data is a set of 3000 random ground states (randomized double wells with a random barrier height and width, random interactions, and a random particle number in them)</p>
<h2><a class="anchor" id="autotoc_md2"></a>
Prerequisites</h2>
<p>As prerequisites to run the python scripts in this repository you will need (at least)</p>
<ul>
<li>Jupyter (for executing the notebook)</li>
<li>Keras (for neural network definition and training)</li>
<li>Tensorflow (backend for Keras)</li>
<li>Tensorflow-Addons (For using interpolation loss)</li>
<li>Matplotlib (for visualizing the results)</li>
<li>Numpy (for numerical manipulations)</li>
</ul>
<h2><a class="anchor" id="autotoc_md3"></a>
Structure of the repository</h2>
<p>Please refer to the flowchart "workflow.pdf" for a graphical depiction of the structure of the modularized code. The <a class="el" href="namespaceUNIQORN.html">UNIQORN</a> python modules related to machine learning tasks are stored mostly in the "source" directory and the python modules and files related to the data generation with MCTDH-X are stored in the directory "MCTDHX-data_generation".</p>
<p>Calculations can be done using the Jupyter notebook <a class="el" href="UNIQORN_8ipynb.html">UNIQORN.ipynb</a> or the python script <a class="el" href="UNIQORN_8py.html">UNIQORN.py</a> . An evaluation of the error of some observables is possible via a formula. For this purpose, the python script <a class="el" href="Error__from__formula_8py.html">Error_from_formula.py</a> can be executed. To perform the (lengthy!) check for the dependence of the neural-network-based regression of observables from input data with a varying amount of single-shot observations per input dataset, the python script <a class="el" href="Regression__Loop__NShots_8py.html">Regression_Loop_NShots.py</a> can be executed.</p>
<p><a class="el" href="namespaceUNIQORN.html">UNIQORN</a>'s directories contain other python modules that have different purposes.</p>
<p>PYTHON MODULES:</p><ul>
<li><a class="el" href="Input_8py.html">Input.py</a>: This python class contains all the parameters of the algorithm, ranging from which observable to reconstruct, to how to batch the input data, to what to visualize or not, etc.</li>
<li><a class="el" href="DataPreprocessing_8py.html">DataPreprocessing.py</a>: This module performs runtime checks for input data consistency, and extracts and manipulates the input data via the subroutine <a class="el" href="DataLoading_8py.html">DataLoading.py</a> depending on the given task (i.e. supervised or unsupervised regression/classification) and on the given observable to fit (e.g. fragmentation, or density, or...). It also splits the input data into training and test sets.</li>
<li><a class="el" href="DataLoading_8py.html">DataLoading.py</a>: This module imports the input data (single shots or correlation functions) and chooses which observables to use as labels (classification) or true values (regression).</li>
<li><a class="el" href="DataGenerator_8py.html">DataGenerator.py</a>: This module implements a class to dynamically load the data on-demand, i.e., batch-by-batch while training and validating the model.</li>
<li><a class="el" href="ModelTrainingAndValidation_8py.html">ModelTrainingAndValidation.py</a>: This module constructs or loads from a library the type of neural network selected in the input file, compiles it, trains it on the training set, and validates it with the test set.</li>
<li><a class="el" href="Models_8py.html">Models.py</a>: This module is a collection of python functions that return various types of neural networks and other Keras model objects to be used in <a class="el" href="ModelTrainingAndValidation_8py.html">ModelTrainingAndValidation.py</a>. There are default models depending on the task to be performed, an archive of tested models, and customizable models.</li>
<li>ModelEvaluation.py: This module executes the validation of an already trained model with the test set.</li>
<li><a class="el" href="Visualization_8py.html">Visualization.py</a>: This module generates and saves as .png files all the results of model training and testing (e.g. accuracies as a function of the epochs), as well as visual comparisons between the test set and the results obtained with the neural networks.</li>
<li><a class="el" href="functions_8py.html">functions.py</a>: This module contains various useful functions to perform sub-tasks.</li>
<li>generate_random_DW_states.py: This python script generates random relaxations with MCTDH-X software to produce the single-shot input data.</li>
</ul>
<p>BASH SCRIPTS (mainly used to generate or import data):</p><ul>
<li>check_convergence.sh: called by generate_random_DW_states.py . Checks if a random relaxation is converged and restarts it, if not.</li>
<li>run_anal.sh: called by generate_random_DW_states.py . If a random relaxation is converged, this script runs the MCTDH-X analysis program on it.</li>
<li>MLG.sh: can be called to parse all python files for a certain string.</li>
</ul>
<p>Currently the code supports only supervised regression tasks. The tasks can be implemented via a multilevel perceptron (MLP) or a convolutional neural network (CNN). Some default and also some customizable models are defined in the file <a class="el" href="Models_8py.html">Models.py</a>. Note that certain quantities such as fragmentation can only be inferred only from multiple (and not a single) single-shot images. The <a class="el" href="DataPreprocessing_8py.html">DataPreprocessing.py</a> function therefore assembles the input data in stacks of multiple single-shot images.</p>
<h2><a class="anchor" id="autotoc_md4"></a>
Running the code for a single set of hyperparameters</h2>
<p>A good start is the jupyter notebook <a class="el" href="UNIQORN_8ipynb.html">UNIQORN.ipynb</a>, which calls all the different modules that perform various tasks.</p>
<p>You can check it out by typing</p>
<p>jupyter notebook</p>
<p>in your shell. This should open a window in your web browser, from which you can navigate to the file <a class="el" href="UNIQORN_8ipynb.html">UNIQORN.ipynb</a> and execute it line by line. The notebook goes through the workflow explained above, i.e.</p>
<p>data loading -&gt; data processing -&gt; model choice, training and validation -&gt; visualization.</p>
<p>The notebook will automatically call and run other modules such as <a class="el" href="DataPreprocessing_8py.html">DataPreprocessing.py</a>, <a class="el" href="ModelTrainingAndValidation_8py.html">ModelTrainingAndValidation.py</a> etc. These files should be modified only if you are a developer implementing new machine learning tasks. Moreover, <a class="el" href="UNIQORN_8ipynb.html">UNIQORN.ipynb</a> is to be seen as a starting point that trains, evaluates and visualizes a model for a single set of model parameters.</p>
<p>To choose which machine learning task to perform (e.g. switching from a regression of the particle number from single shots to a classification of fragmented/non-fragmented states from correlation functions), you need to modify the input file (python class) <a class="el" href="Input_8py.html">Input.py</a>. This file contains all the different knobs and variables for the machine learning algorithms, including hyperparameters such as batch size or number of epochs. In here, you can also select which quantity to fit and how, and whether or not you want to load a pre-trained neural network or train it yourself, visualize the results or not etc. The input file and the role of each variable therein should be self-explanatory.</p>
<p>Note that the notebook produces results in line while being executed, but the corresponding figures are also saved in the various folders in the main folder "plots" for later retrieval. The paths to these files and the files themselves are named after the quantity being fitted. For example, a plot of the accuracy of the regression of the particle number from single shots in real space during 20 epochs will be saved in the folder "plots/NPAR/accuracies", with the name "Accuracies-for-REGR-of-NPAR-from-SSS-in-x-space-during-20-epochs.png"</p>
<h2><a class="anchor" id="autotoc_md5"></a>
Performing a hyperparameter optimization with HPBandster</h2>
<p>It is a tough task to optimally configure all the possible parameters of deep learning models. However, since hyperparameter optimization is an optimization task, it can be automated. One library that provides out-of-the-box hyperparameter optimization is the HpBandSter library. See <a href="https://github.com/automl/HpBandSter">this link</a> for details about HpBandSter. Obviously, the HpBandSter library is a prerequisite for running the code.</p>
<p>Currently, we only provide an HpBandSter implementation for optimizing convolutional neural networks (Set Model='custom' and ConvNet=True in <a class="el" href="Input_8py.html">Input.py</a>). You can run the hyperparameter optimization by executing</p>
<ul>
<li>python <a class="el" href="HyperParameterOpt_8py.html">HyperParameterOpt.py</a></li>
</ul>
<p>This will then perform an optimization which you can visualize by running</p>
<ul>
<li>python <a class="el" href="PlotInteractiveHyperParameterOpt_8py.html">PlotInteractiveHyperParameterOpt.py</a></li>
</ul>
<p>This will open plot the results of the optimization run. By clicking on the point in the plot with the lowest loss, you can find out the optimal set of hyperparameters, i.e., the result of the optimization. </p>
</div></div><!-- PageDoc -->
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
